#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GiantSharkRanking.h"
std::auto_ptr<Fish_GiantSharkRanking> Fish_GiantSharkRanking::msSingleton(nullptr);

int Fish_GiantSharkRanking::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiantSharkRankingData* Fish_GiantSharkRanking::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GiantSharkRankingData>& Fish_GiantSharkRanking::GetMapData()
{
	return mMapData;
}

void Fish_GiantSharkRanking::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GiantSharkRanking.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiantSharkRankingData data;
		data.mID = element->IntAttribute("ID");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		data.mLimit = element->IntAttribute("Limit");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GiantSharkRanking Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkRanking::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GiantSharkRanking");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GiantSharkRanking");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GiantSharkRankingData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "StartRank", data.mStartRank);
		LuaCfgHelper::readInt(L, "EndRank", data.mEndRank);
		LuaCfgHelper::readVectorInt(L, "RewardList", data.mRewardList);
		LuaCfgHelper::readInt(L, "Limit", data.mLimit);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GiantSharkRanking Loaded. Load Data:%u", mMapData.size());
}

void Fish_GiantSharkRanking::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GiantSharkRanking* Fish_GiantSharkRanking::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiantSharkRanking());
	}
	return msSingleton.get();
}

void Fish_GiantSharkRanking::Release()
{
	msSingleton.reset(nullptr);
}
